<?php
 
 
 

namespace PhpWA\Protocol\Proto;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\GPBUtil;
use Google\Protobuf\RepeatedField;




class ADVDeviceIdentity extends \Google\Protobuf\Internal\Message
{
    


    protected $rawId = null;
    


    protected $timestamp = null;
    


    protected $keyIndex = null;
    


    protected $accountType = null;
    


    protected $deviceType = null;

    












    public function __construct($data = NULL) {
        \PhpWA\Protocol\Proto\Metadata\WAProto::initOnce();
        parent::__construct($data);
    }

    



    public function getRawId()
    {
        return isset($this->rawId) ? $this->rawId : 0;
    }

    public function hasRawId()
    {
        return isset($this->rawId);
    }

    public function clearRawId()
    {
        unset($this->rawId);
    }

    




    public function setRawId($var)
    {
        GPBUtil::checkUint32($var);
        $this->rawId = $var;

        return $this;
    }

    



    public function getTimestamp()
    {
        return isset($this->timestamp) ? $this->timestamp : 0;
    }

    public function hasTimestamp()
    {
        return isset($this->timestamp);
    }

    public function clearTimestamp()
    {
        unset($this->timestamp);
    }

    




    public function setTimestamp($var)
    {
        GPBUtil::checkUint64($var);
        $this->timestamp = $var;

        return $this;
    }

    



    public function getKeyIndex()
    {
        return isset($this->keyIndex) ? $this->keyIndex : 0;
    }

    public function hasKeyIndex()
    {
        return isset($this->keyIndex);
    }

    public function clearKeyIndex()
    {
        unset($this->keyIndex);
    }

    




    public function setKeyIndex($var)
    {
        GPBUtil::checkUint32($var);
        $this->keyIndex = $var;

        return $this;
    }

    



    public function getAccountType()
    {
        return isset($this->accountType) ? $this->accountType : 0;
    }

    public function hasAccountType()
    {
        return isset($this->accountType);
    }

    public function clearAccountType()
    {
        unset($this->accountType);
    }

    




    public function setAccountType($var)
    {
        GPBUtil::checkEnum($var, \PhpWA\Protocol\Proto\ADVEncryptionType::class);
        $this->accountType = $var;

        return $this;
    }

    



    public function getDeviceType()
    {
        return isset($this->deviceType) ? $this->deviceType : 0;
    }

    public function hasDeviceType()
    {
        return isset($this->deviceType);
    }

    public function clearDeviceType()
    {
        unset($this->deviceType);
    }

    




    public function setDeviceType($var)
    {
        GPBUtil::checkEnum($var, \PhpWA\Protocol\Proto\ADVEncryptionType::class);
        $this->deviceType = $var;

        return $this;
    }

}

